--[[
	self.modelscale:SetValues(4, scalevector.z) etc isn't working, only the last set works
	
	local bone self.Entity:GetNWString("bone")
	local angles = self.Entity:GetNWAngle("angles")
	local offset = self.Entity:GetNWVector("offsetvector")
	local scale = self.Entity:GetNWFloat("scale")  
	local scalevector = self.Entity:GetNWVector("scalevector")
	
	If you just provide setvalue for all the sliders, I could do the rest.
]]

local matHover = Material( "vgui/spawnmenu/hover" )

PAC_EDITOR = nil

PAC_OUTFIT = {} // The outfits table
PAC_OUTFIT.PARTS = {} //The parts inside that

local MODULE = {}

AccessorFunc( MODULE, "collapsed", "Collapsed", FORCE_BOOL )

MODULE.lastclick = RealTime()
MODULE.oldtall = 0

function MODULE:Init()
end

function MODULE:OnMousePressed()
	local x,y = self:LocalToScreen(self:GetPos())
	if math.abs((gui.MouseY() * 2) - y) < 26 then
		if RealTime() - self.lastclick < 0.2 then
			if self:GetCollapsed() then
				self:UnCollapse()
			else
				self:Collapse()
			end
		end
		self.lastclick = RealTime()
	end
	
	if ( !self:GetDraggable() ) then return end
	self.Dragging = { gui.MouseX() - self.x, gui.MouseY() - self.y }
	self:MouseCapture( true )
end

function MODULE:Think()
	local x,y = self:GetPos()
	if ( self:GetScreenLock() ) then
	
		x = math.Clamp( x, 0, ScrW() - self:GetWide() )
		y = math.Clamp( y, 0, ScrH() - self:GetTall() )
	
	end
	self:SetPos( x, y )
	if (!self.Dragging) then return end
	
	x = gui.MouseX() - self.Dragging[1]
	y = gui.MouseY() - self.Dragging[2]

	self:SetPos( x, y )
	
end

function MODULE:Close()
	if self:GetCollapsed() then
		self:UnCollapse()
	else
		self:Collapse()
	end
end


--[[function MODULE:PaintOver() //Debug to get good pos's for modules!
	--local x,y = self:GetPos()
	--draw.SimpleText("X "..x.." Y "..y, "ScoreboardText", 30, 3)
end]]

function MODULE:Collapse()
	self.oldtall = self:GetTall()
	if self.oldpos then
		self:SetPos(self.oldpos[1],self.oldpos[2])
	end
	self:SetTall(21)
	self:SetCollapsed(true)
end

function MODULE:UnCollapse()
	local x,y = self:GetPos()
	self.oldpos = {x,y}
	self:SetCollapsed(false)
	self:SetSize(self:GetWide(), self.oldtall)
end

function MODULE:OnMouseReleased()
	self.Dragging = nil
	self:MouseCapture( false )
end

local COL_GREY = Color(50,50,50,255)
local COL_LGREY = Color(100,100,100,255)
local COL_BLACK = Color(0,0,0,255)

function MODULE:Paint()
	surface.SetDrawColor(COL_GREY)
	surface.DrawRect(0,0,self:GetWide(),self:GetTall())
	surface.SetDrawColor(COL_BLACK)
	surface.DrawOutlinedRect(0,0,self:GetWide(),self:GetTall())
	surface.SetDrawColor(COL_LGREY)
	surface.DrawRect(0,0,self:GetWide(),21)
	surface.SetDrawColor(COL_BLACK)
	surface.DrawOutlinedRect(0,0,self:GetWide(),21)
end

vgui.Register("PAC_Module", MODULE, "DFrame")

local SLIDERS = {}

function SLIDERS:Init()
	self:SetSize(300,155) // Play around with this size
	self.list = vgui.Create("DPanelList", self)
	self.list:SetSpacing(5)
	self.list:SetPadding(4)
	self.sliders = {}
end

function SLIDERS:AddSlider(title,min,max)
	local slid = vgui.Create("DNumSlider", self)
	slid:SetText(title)
	slid:SetMin(min)
	slid:SetMax(max)
	function slid.Wang:SetValue( val ) // This is done to override the check that stops you changing the value when the wang has focus
		if ( val == nil ) then return end
		local OldValue = val
		val = tonumber( val )
		val = val or 0
		if ( self.m_iDecimals == 0 ) then
			val = Format( "%i", val )
		elseif ( val != 0 ) then
			val = Format( "%."..self.m_iDecimals.."f", val )
			val = string.TrimRight( val, "0" )		
			val = string.TrimRight( val, "." )
		end
		self.TextEntry:SetText( val )
		self.TextEntry:ConVarChanged( val )
		self:OnValueChanged( val )
	end
	self.list:AddItem(slid)
	table.insert(self.sliders, slid)
end

function SLIDERS:GetSliders()
	return self.sliders
end

function SLIDERS:SetValues(key, number)
	if self.sliders[key] then
		self.sliders[key]:SetValue(number)
	end
end

function SLIDERS:PerformLayout()
	if self.Collapsed then return end
	self:SetSize(self:GetWide(), #self.sliders * 50) // FIDDLE WITH SECOND ARG!!!!!
	self.list:StretchToParent(2,25,2,2)
	derma.SkinHook( "Layout", "Frame", self )
end

vgui.Register( "PAC_Sliders" , SLIDERS, "PAC_Module")


local PREVIEW = {}

AccessorFunc( PREVIEW, "Player", "Entity" )
AccessorFunc( PREVIEW, "vCamPos", "CamPos" )
AccessorFunc( PREVIEW, "fFOV", "FOV" )
AccessorFunc( PREVIEW, "vLookatPos", "LookAt" )
AccessorFunc( PREVIEW, "colAmbientLight", "AmbientLight" )
AccessorFunc( PREVIEW, "bAnimated",               "Animated" )
AccessorFunc( PREVIEW, "m_fAnimSpeed",    "AnimSpeed" )

--AccessorFunc( PREVIEW, "colColor", "Color" )

function PREVIEW:Init()
	self.Player = nil
	self.Parts = {}
	self.LastPaint = 0
	self.DirectionalLight = {}
	self.m_fAnimSpeed = 1
	
	self:SetCamPos( Vector( 50, 50, 50 ) )
	self:SetLookAt( Vector( 0, 0, 40 ) )
	self:SetFOV( 70 )
	
	self:SetText( "" )
	
	self:SetAmbientLight( Color( 50, 50, 50 ) )
	
	self:SetDirectionalLight( BOX_TOP, Color( 255, 255, 255 ) )
	self:SetDirectionalLight( BOX_FRONT, Color( 255, 255, 255 ) )
	
	--self:SetColor( Color( 255, 255, 255, 255 ) )
	self:SetModel()
	
	if ( !ClientsideModel ) then return end
	
	self.Player = ClientsideModel( LocalPlayer():GetModel(), RENDER_GROUP_OPAQUE_ENTITY )
	
	if ( !IsValid(self.Player) ) then return end
	
	self.Player:SetNoDraw( true )	
end

function PREVIEW:SetDirectionalLight( iDirection, color )
	self.DirectionalLight[iDirection] = color
end

function PREVIEW:AddPart(path,removeold)
	local ent = ClientsideModel( path, RENDER_GROUP_OPAQUE_ENTITY )
	ent:SetNoDraw(true)
	table.insert(self.Parts,ent)
	for k,v in pairs(self.Parts) do
		self:SetColor(k,255,255,255,255)
	end
	return ent
end

function PREVIEW:SetColor(part,R,G,B,A)
	self.Parts[part].color = {}
	self.Parts[part].color.r = R	
	self.Parts[part].color.g = G
	self.Parts[part].color.b = B	
	self.Parts[part].color.a = A	
end

function PREVIEW:GetParts()
	return self.Parts
end

function PREVIEW:Paint()
	if ( !IsValid( self.Player ) ) then return end
	
	local x, y = self:LocalToScreen( 0, 0 )
		
	cam.Start3D( self.vCamPos, (self.vLookatPos-self.vCamPos):Angle(), self.fFOV, x, y, self:GetWide(), self:GetTall() )
	cam.IgnoreZ( true )
	
	render.SuppressEngineLighting( true )
	render.SetLightingOrigin( self.Player:GetPos() + Vector(0,0,60) )
	render.ResetModelLighting( self.colAmbientLight.r/255, self.colAmbientLight.g/255, self.colAmbientLight.b/255 )
	
	for i=0, 6 do
		local col = self.DirectionalLight[ i ]
		if ( col ) then
			render.SetModelLighting( i, col.r/255, col.g/255, col.b/255 )
		end
	end
	
	if self:GetAnimated() then
		self:RunAnimation()
	end
	
	self.Player:SetAngles(Angle(0,self.XYSlider:GetSlideX()*360-90 or 0,0))
	self:SetFOV(math.Clamp(self.XYSlider:GetSlideY()*100, 5, 100))
	
	self.Player:DrawModel()
	
	for k,v in pairs(self.Parts) do
		render.SetColorModulation( v.color.r/255, v.color.g/255, v.color.b/255 )
		render.SetBlend( v.color.a/255 )
		v:DrawModel()
	end
		
	render.SuppressEngineLighting( false )
	cam.IgnoreZ( false )
	cam.End3D()
	
	for k,v in pairs(PAC_EDITOR.modules) do
		--v:PaintManual()
	end
	
	self.LastPaint = RealTime()
	
end

function PREVIEW:RunAnimation()
    self:GetEntity():FrameAdvance( (RealTime()-self.LastPaint) * self.m_fAnimSpeed)    
end

function PREVIEW:PerformLayout()
end

vgui.Register( "PAC_dmodel", PREVIEW, "DButton" )

local PREVFRAME = {}

function PREVFRAME:Init()
	self:SetTitle("Preview")
	PAC_EDITOR.preview = vgui.Create("PAC_dmodel", self)
	local size = ScrW() * 0.8
	if ScrH() * 0.8 < size then size = ScrH() * 0.8 end
	self:SetSize(size,size)
	self:SetTitle("Preview")
	PAC_EDITOR.preview:SetPos(5, 26)
	PAC_EDITOR.preview:SetSize(size - 10,size - 31)
	PAC_EDITOR.preview:SetCamPos(Vector( 0, 50, 60 ))
	PAC_EDITOR.preview:SetLookAt(Vector( 0, 0, 65 ))
	PAC_EDITOR.preview:SetFOV(40)
end

vgui.Register("PAC_PreviewFrame", PREVFRAME, "PAC_Module")

local MODELSLIDER = {}

function MODELSLIDER:Init()
	self:SetTitle("View Control")
	self:SetSize(200,200)
	self.slider = vgui.Create("DSlider", self)
	self.slider:StretchToParent(9,29,9,9)
end

vgui.Register("PAC_ModSlid", MODELSLIDER, "PAC_Module")

local EDITOR = {}

function EDITOR:Init()
	self.NextThink = RealTime()
	self:SetSize(ScrW(), ScrH())
	self:Center()
	self:SetTitle( "The Player Apparance Customizer" )
	self:ShowCloseButton( true )
	self:MakePopup()
	self:SetDraggable(true)
	self.modules = {}
	PAC_EDITOR = self

	self.prevframe = vgui.Create("PAC_PreviewFrame", self) 
	self.prevframe:SetPos(self:GetWide() - 300 - self.prevframe:GetWide() - 10,120)
		
	self.modslid = vgui.Create("PAC_ModSlid",self)
	local x,y = self.prevframe:GetPos()
	self.modslid:SetPos(20,y + self.prevframe:GetTall() - self.modslid:GetTall())
	table.insert(self.modules,self.modslid)
	
	self.preview.XYSlider = self.modslid.slider

	self.xyz = vgui.Create("PAC_Sliders",self)
	self.xyz:SetTitle("Offset")
	self.xyz:AddSlider("X", -100, 100)
	self.xyz:AddSlider("Y", -100, 100)
	self.xyz:AddSlider("Z", -100, 100)
	local vector = LocalPlayer():GetNWEntity("pac_lastpartworn"):GetNWVector("offset")
	self.xyz:SetValues(1, vector.x)
	self.xyz:SetValues(2, vector.y)
	self.xyz:SetValues(3, vector.z)
	
	table.insert(self.modules,self.xyz)
	
	self.angles = vgui.Create("PAC_Sliders",self)
	self.angles:SetTitle("Angles")
	self.angles:AddSlider("Pitch", -180, 180)
	self.angles:AddSlider("Yaw", -180, 180)
	self.angles:AddSlider("Roll", -180, 180)
	local angle = LocalPlayer():GetNWEntity("pac_lastpartworn"):GetNWAngle("anlges")
	self.angles:SetValues(1, angle.p)
	self.angles:SetValues(2, angle.y)
	self.angles:SetValues(3, angle.r)
	
	table.insert(self.modules,self.angles)
	
	self.modelscale = vgui.Create("PAC_Sliders",self)
	self.modelscale:SetTitle("Model Scale")
	self.modelscale:AddSlider("Scale", 0, 10)
	self.modelscale:AddSlider("X", 0, 10)
	self.modelscale:AddSlider("Y", 0, 10)
	self.modelscale:AddSlider("Z", 0, 10)
	local scale = LocalPlayer():GetNWEntity("pac_lastpartworn"):GetNWAngle("scale")
	local scalevector = LocalPlayer():GetNWEntity("pac_lastpartworn"):GetNWAngle("scalevector")
	
	self.modelscale:SetValues(1, LocalPlayer():GetNWEntity("pac_lastpartworn"):GetNWAngle("scale"))
	self.modelscale:SetValues(2, scalevector.y)
	self.modelscale:SetValues(3, scalevector.y)
	self.modelscale:SetValues(4, scalevector.z)
	
	table.insert(self.modules,self.modelscale)
	
	
	self.color = vgui.Create("PACMixer",self)
	self.color:SetSize(195,150)
	
	table.insert(self.modules,self.color)
	
	self.xyz:SetPos(self:GetWide() - self.xyz:GetWide()-5, 120)
	
	self.angles:SetPos(self:GetWide() - self.angles:GetWide() - 5, 271)
	
	self.color:SetPos(self:GetWide() - self.color:GetWide() - 5, 622)
	
	self.modelscale:SetPos(self:GetWide() - self.modelscale:GetWide() - 5, 422)
	
	self.parts = vgui.Create("PAC_PartsMenu",self)
	self.parts:SetSize(self:GetWide() - 10,90)
	self.parts:SetPos(5, 25)
	table.insert(self.modules,self.parts)
	
	self.bonechange = vgui.Create("PAC_BoneChange",self)
	self.bonechange:SetPos(20,235)
	table.insert(self.modules,self.bonechange)
	
	self.filesave = vgui.Create("PAC_FileSave", self)
	self.filesave:SetPos(20,300)
	table.insert(self.modules,self.filesave)
	
	self.matchange = vgui.Create("PAC_MatChange",self)

	table.insert(self.modules,self.matchange)
	
	self.animator = vgui.Create("PAC_Animator",self)
	self.animator:SetPos(20,130)
	//self.animator:Collapse()
	table.insert(self.modules,self.filesave)
	
	
	--self:AddPart("models/props_borealis/bluebarrel001.mdl")// TODO: Add the new part menu
	--self:AddPart("models/props_c17/canister_propane01a.mdl")// TODO: Add the new part menu
end

function EDITOR:AddPart(model,material)
	local t = {}
	t.Pos = Vector(0,0,0)
	t.Bone = "ValveBiped.Bip01_Head1"
	t.Angles = Angle(0,0,0)
	t.Color = Color(255,255,255,255)
	t.Scale = {1,1,1,1}
	t.Mat = material
	t.Ent = self.preview:AddPart(model,true) // this func also returns the part entity!
	table.insert(PAC_OUTFIT.PARTS, t)
	self:SetPart(#PAC_OUTFIT.PARTS) // Set part to the newest one :D
	self.parts:AddPart(model,#PAC_OUTFIT.PARTS,t)
end

function EDITOR:LoadPart(arguments)
	local name = arguments[1]
	local model = arguments[2]

	local x = -arguments[3]
	local y = arguments[4]
	local z = arguments[5]

	local scale = arguments[6]

	local pitch = -arguments[7]
	local yaw = arguments[8]
	local roll = arguments[9]

	local scalex = arguments[10]
	local scaley = arguments[11]
	local scalez = arguments[12]

	local r = arguments[13]
	local g = arguments[14]
	local b = arguments[15]
	local a = arguments[16]

	local bone = arguments[17]

	local material = arguments[18]
	
	local t = {}
	
	t.Pos = Vector(x,y,z)
	t.Bone = bone
	t.Angles = Angle(pitch,yaw,roll)
	t.Color = Color(r,g,b,a)
	t.Scale = {scale,scalex,scaley,scalez}
	t.Mat = material
	t.Ent = self.preview:AddPart(model,true) // this func also returns the part entity!
	t.Ent:SetMaterial(t.Mat)
	table.insert(PAC_OUTFIT.PARTS, t)
	self:SetPart(#PAC_OUTFIT.PARTS) // Set part to the newest one :D
	self.parts:AddPart(model,#PAC_OUTFIT.PARTS,t)
end

function EDITOR:ModifyPart(tab,model)
	if !tab then return end
	local spawnitems = self.parts.list:GetItems()
	for k,v in pairs(spawnitems) do
		if tab.Ent == v.Tab.Ent then
			v.Icon:Remove()
			v.Icon = vgui.Create( "ModelImage", v )
			v.Icon:SetMouseInputEnabled( false )
	        v.Icon:SetKeyboardInputEnabled( false ) // :/ rebuild spawnicon's icon (hacky but only way I know of)
			v.Icon:SetModel(model)
			v.iconmodel = model
		end
	end
	tab.Ent:SetModel(model)
end

function EDITOR:GetPartID(ent)
	for k,v in pairs(PAC_OUTFIT.PARTS) do if v.Ent == ent then return k end end
end

function EDITOR:SetPart(ID)
	local part = PAC_OUTFIT.PARTS[ID]
	
	local xyz_slids = self.xyz:GetSliders()
	local ang_slids = self.angles:GetSliders()
	local mod_scale = self.modelscale:GetSliders()

	xyz_slids[1]:SetValue(part.Pos.x) // This is long winded but it works
	xyz_slids[2]:SetValue(part.Pos.y)
	xyz_slids[3]:SetValue(part.Pos.z)

	ang_slids[1]:SetValue(part.Angles.p)
	ang_slids[2]:SetValue(part.Angles.y)
	ang_slids[3]:SetValue(part.Angles.r)
	
	self.color:SetColor(part.Color)

	self.bonechange.bone_drop:SetText(self.bonechange:TranslateNameToBone(part.Bone))
	
	for k,v in pairs(mod_scale) do
		v:SetValue(part.Scale[k])
	end
	self.CURRENT_PART = part
end

function EDITOR:Think()
	if self.NextThink < RealTime() then
	if self.CURRENT_PART then
		for k,v in pairs(self.preview:GetParts()) do // Loop through all current parts and update their positions
			local CUR_PART_ID = self:GetPartID(v)
			local CUR_PART_TAB = PAC_OUTFIT.PARTS[CUR_PART_ID]
			local Bone = self.preview:GetEntity():LookupBone(CUR_PART_TAB.Bone or "ValveBiped.Bip01_Head1")
			if Bone then
				local Position, Angles = self.preview:GetEntity():GetBonePosition(Bone)
				local xyz = self.xyz:GetSliders()
				local X = Angles:Up() * -CUR_PART_TAB.Pos.x
				local Y = Angles:Right() * CUR_PART_TAB.Pos.y
				local Z = Angles:Forward() * CUR_PART_TAB.Pos.z
			
				local Pitch = -CUR_PART_TAB.Angles.p
				local Yaw = CUR_PART_TAB.Angles.y
				local Roll = CUR_PART_TAB.Angles.r
				
				Angles:RotateAroundAxis(Angles:Forward(), Pitch)
				Angles:RotateAroundAxis(Angles:Right(), Yaw)
				Angles:RotateAroundAxis(Angles:Up(), Roll)
				
				CUR_PART_TAB.Ent:SetPos(Position + X + Y + Z)
				CUR_PART_TAB.Ent:SetAngles(Angles)
				CUR_PART_TAB.Ent:SetColor(CUR_PART_TAB.Color.r,CUR_PART_TAB.Color.g,CUR_PART_TAB.Color.b,CUR_PART_TAB.Color.a)
				
				local scales = CUR_PART_TAB.Scale
				local modscale = Vector(scales[2],scales[3],scales[4]) * scales[1]
				CUR_PART_TAB.Ent:SetModelScale(modscale)
				
				//Updates the ACTIVE PART ONLY
				local tab = PAC_OUTFIT.PARTS[self:GetPartID(self.CURRENT_PART.Ent)]
				local ibone = self.preview:GetEntity():LookupBone(tab.Bone)
				local campos = self.preview:GetEntity():GetBonePosition(ibone)
				self.preview:SetLookAt(campos)	
				tab.Pos = Vector(xyz[1]:GetValue(),xyz[2]:GetValue(),xyz[3]:GetValue())
				local angs = self.angles:GetSliders()
				tab.Angles = Angle(angs[1]:GetValue(),angs[2]:GetValue(),angs[3]:GetValue())
				tab.Scale = {}
				local scale = self.modelscale:GetSliders()
				for k,v in pairs(scale) do
					table.insert(tab.Scale, v:GetValue())
				end
				local R = self.color:GetColor().r
				local G = self.color:GetColor().g
				local B = self.color:GetColor().b
				local A = self.color:GetColor().a 
				for k,v in pairs(self.preview:GetParts()) do
					if v == self.CURRENT_PART.Ent then
						self.preview:SetColor(k,R,G,B,A)
					end
				end
				tab.Color = Color(R,G,B,A)
			end
		end
	end
	self.NextThink = RealTime() // No delay
	end
	self.BaseClass.Think(self)
end

function EDITOR:PerformLayout()
	derma.SkinHook( "Layout", "Frame", self )
end

function EDITOR:OnRemove()
	for k,v in pairs(self.modules) do
		v:Remove()
	end
end

vgui.Register( "PAC_Editor" , EDITOR, "DFrame" )

local MIXER = {}

function MIXER:Init()
	self:SetTitle("Part Colour")
	self.color = vgui.Create("DColorMixer", self)
	self.color:SetSize(205,120)
	self.color:SetPos(5,25)
end

function MIXER:GetColor()
	color = self.color:GetColor()
	color.a = 255 - ((self.color.AlphaBar:GetSlideY() or 0) * 255)
	return color
end

function MIXER:SetColor( color )
	self.color:SetColor(color)
	self.color:SetBaseColor( color )
end

vgui.Register("PACMixer", MIXER, "PAC_Module")

PAC_NEWPART = nil

local PARTS = {}

function PARTS:Init()
	self.list = vgui.Create("DPanelList",self)
	self.list:SetPos(7,20)
	self.list:SetAutoSize(true)
	self.list:EnableHorizontal(true)
	self.list:EnableVerticalScrollbar(true)
	self:SetTitle("Parts")
	self.new = vgui.Create("DButton", self)
	self.new:SetText("+")
	self.new:SetSize(64,64)
	self.new.DoClick = function(but) if ValidPanel(PAC_NEWPART) then PAC_NEWPART.editmodetab = nil PAC_NEWPART:SetVisible(true) PAC_NEWPART:MakePopup() else PAC_NEWPART = vgui.Create("PAC_NewPart") end end
end

function PARTS:AddPart(MODEL,ID,Tab)
	local part = vgui.Create("SpawnIcon",self) // This requires sandbox but I cba to make a custom one :D
	part:SetModel(MODEL)
	function part:OnCursorEntered( )
		--[[for k,v in pairs(PAC_EDITOR.preview:GetParts()) do
			if v != Tab.Ent and Tab.Ent != PAC_EDITOR.CURRENT_PART.Ent then
				local col = PAC_OUTFIT.PARTS[ID].Color
				PAC_EDITOR.preview:SetColor(k, col.r,col.g,col.b,100)
			end
		end]]
        self.PaintOverOld = self.PaintOver
        self.PaintOver = self.PaintOverHovered
	end
	function part:OnCursorExited( )
		--[[for k,v in pairs(PAC_EDITOR.preview:GetParts()) do
			if v != Tab.Ent and Tab.Ent != PAC_EDITOR.CURRENT_PART.Ent then
				local col = PAC_OUTFIT.PARTS[ID].Color
				PAC_EDITOR.preview:SetColor(k, col.r,col.g,col.b,col.a)
			end
		end]]
        if ( self.PaintOver == self.PaintOverHovered ) then
            self.PaintOver = self.PaintOverOld
        end
	end
	function part:PaintOver()
		if PAC_EDITOR.CURRENT_PART.Ent == Tab.Ent then
			surface.SetDrawColor( 255, 255, 255, 255 )
			surface.SetMaterial( matHover )
			self:DrawTexturedRect()
		end
	end
	part.Tab = Tab
	function part:DoClick() PAC_EDITOR:SetPart(ID) end
	part.OpenMenu = function (part) self:OpenContextMenu( MODEL, part ) end
	self.list:AddItem(part)
	--self.list:InvalidateLayout()
	self:InvalidateLayout()
end

function PARTS:OpenContextMenu(model,icon)
	local menu = DermaMenu()
	menu:AddOption( "Edit Part", function() if ValidPanel(PAC_NEWPART) then PAC_NEWPART.editmodetab = icon.Tab PAC_NEWPART:SetVisible(true) PAC_NEWPART:MakePopup() else PAC_NEWPART = vgui.Create("PAC_NewPart") PAC_NEWPART.editmodetab = icon.Tab end end )
	menu:AddOption( "Copy Part", function() 
									local t = table.Copy(icon.Tab)
									t.Ent = PAC_EDITOR.preview:AddPart(icon.Tab.Ent:GetModel(),true) // this func also returns the part entity!
									table.insert(PAC_OUTFIT.PARTS, t)
									PAC_EDITOR:SetPart(#PAC_OUTFIT.PARTS) // Set part to the newest one :D
									PAC_EDITOR.parts:AddPart(icon.Tab.Ent:GetModel(),#PAC_OUTFIT.PARTS,t)
								end )
	menu:Open()
end

function PARTS:PerformLayout()
	self.list:StretchToParent(2,23,self.new:GetWide() + 10,2)
	self.new:SetPos(self:GetWide() - self.new:GetWide() - 4, 23)
	derma.SkinHook( "Layout", "Frame", self )
end

vgui.Register("PAC_PartsMenu", PARTS, "PAC_Module")

local BoneList = 
{
{"ValveBiped.Bip01_Pelvis", "Pelvis" },
{"ValveBiped.Bip01_Spine", "Spine 1" },
{"ValveBiped.Bip01_Spine1", "Spine 2" },
{"ValveBiped.Bip01_Spine2", "Spine 3" },
{"ValveBiped.Bip01_Spine4", "Spine 4" },
{"ValveBiped.Bip01_Neck1", "Neck" },
{"ValveBiped.Bip01_Head1", "Head" },
{"ValveBiped.Bip01_R_Clavicle", "Right Clavicle" },
{"ValveBiped.Bip01_R_UpperArm", "Right Upper Arm" },
{"ValveBiped.Bip01_R_Forearm", "Right Forearm" },
{"ValveBiped.Bip01_R_Hand", "Right Hand" },
{"ValveBiped.Bip01_L_Clavicle", "Clavicle" },
{"ValveBiped.Bip01_L_UpperArm", "Left Upper Arm" },
{"ValveBiped.Bip01_L_Forearm", "Left Forearm" },
{"ValveBiped.Bip01_L_Hand", "Left Hand" },
{"ValveBiped.Bip01_R_Thigh", "Right Thigh" },
{"ValveBiped.Bip01_R_Calf", "Right Calf" },
{"ValveBiped.Bip01_R_Foot", "Right Foot" },
{"ValveBiped.Bip01_R_Toe0", "Right Toe" },
{"ValveBiped.Bip01_L_Thigh", "Left Thigh" },
{"ValveBiped.Bip01_L_Calf", "Left Calf" },
{"ValveBiped.Bip01_L_Foot", "Left Foot" },
{"ValveBiped.Bip01_L_Toe0", "Left Toe" }
}

local NEWPART = {}

function NEWPART:Init()
	self:SetSize(600,600)
	self:Center()
	self:SetTitle( "Add New Part" )
	self:ShowCloseButton( true )
	self:MakePopup()
	self:SetDeleteOnClose(false)
	
	self.browser = vgui.Create("PAC_Browser", self)
	self.browser:StretchToParent(2,26,2,26)
end

vgui.Register("PAC_NewPart", NEWPART, "DFrame")

local BONECHANGER = {}

function BONECHANGER:Init()
	self:SetTitle("Bone")
	self:SetSize(200,60)
	self.bone_drop = vgui.Create( "DMultiChoice", self)
	self.bone_drop:SetPos(5, 25)
	self.bone_drop:SetSize(self:GetWide() - 65,21)
	self.bone_drop:SetEditable(false)
	for Index, Bone in pairs(BoneList) do
		self.bone_drop:AddChoice(Bone[2])
	end
	self.bone_drop:ChooseOptionID(1)
	self.changebut = vgui.Create("DButton", self)
	self.changebut:SetText("Change")
	self.changebut:SetPos(self:GetWide() - 55, 25)
	self.changebut:SetSize(50,21)
	self.changebut.DoClick = function (but)	
								local tab = PAC_OUTFIT.PARTS[PAC_EDITOR:GetPartID(PAC_EDITOR.CURRENT_PART.Ent)]
								tab.Bone = self:TranslateBoneToName()
								PAC_EDITOR.NextThink = RealTime() + 0.2 // THIS IS DONE BECAUSE FOR SOME STRANGE REASON THE GAME CRASHES IF THE BONE IS LOADED INSTANTLY.
							end
end

function BONECHANGER:TranslateBoneToName()
	for k, v in pairs(BoneList) do
		if self.bone_drop.TextEntry:GetValue() == v[2] then
			return v[1]
		end
	end
end

function BONECHANGER:TranslateNameToBone(name)
	for k, v in pairs(BoneList) do
		if name == v[1] then
			return v[2]
		end
	end
end

vgui.Register("PAC_BoneChange", BONECHANGER, "PAC_Module")

local MAT = {}

function MAT:Init()
	self:SetTitle("Material Browser")
	self:SetSize(415,430)
	self:Collapse()
	self:SetPos((PAC_EDITOR:GetWide() / 2) - (self:GetWide() / 2),PAC_EDITOR:GetTall() - 21)
	self.matselect = vgui.Create("MatSelect", self)
	self.matselect:SetNumRows(3)
	self:SetDraggable(false)
	function self.matselect:AddMaterial(v) // Override default add mat func
		local Mat = vgui.Create( "DImageButton", self )
		Mat:SetOnViewMaterial( v, "models/wireframe" )
		Mat.AutoSize = false
		Mat.Value = v
		Mat:SetSize( self.ItemWidth, self.ItemHeight )
		Mat:SetToolTip(v)
		
		// Run a console command when the Icon is clicked
		Mat.DoClick = function (Mat)	
							local tab = PAC_OUTFIT.PARTS[PAC_EDITOR:GetPartID(PAC_EDITOR.CURRENT_PART.Ent)]
							tab.Mat = v
							tab.Ent:SetMaterial(v)
					  end
		Mat.DoRightClick = function (Mat)	
					local tab = PAC_OUTFIT.PARTS[PAC_EDITOR:GetPartID(PAC_EDITOR.CURRENT_PART.Ent)]
					tab.Mat = nil
					tab.Ent:SetMaterial()
			  end
		// Add the Icon us
		self.List:AddItem( Mat )
		table.insert( self.Controls, Mat )
		
		self:InvalidateLayout()
	end
	for k,v in pairs(list.Get( "OverrideMaterials" )) do
		self.matselect:AddMaterial(v,v)
	end
	self.matselect:StretchToParent(2,26,2,2)
end

vgui.Register("PAC_MatChange", MAT, "PAC_Module")

local SAVE = {}

function SAVE:Init()
	self:SetTitle("Save Options")
	self:SetSize(200,200)
	
	self.but = vgui.Create( "DButton", self )
	self.but:SetSize( self:GetWide() - 10, 20 )
	self.but:SetPos( 5, 77)
	self.but:SetText( "Save to server" )
	self.but.DoClick = function (but) SaveToServer(self.FileName:GetValue(), self.check:GetChecked(true)) end
	
	self.but2 = vgui.Create( "DButton", self )
	self.but2:SetSize( self:GetWide() - 10, 20 )
	self.but2:SetPos( 5, 102)
	self.but2:SetText( "Save to client" )
	self.but2.DoClick = function (but) SaveToClient(self.FileName:GetValue(), self.check:GetChecked(true)) end
	
	self.FileName = vgui.Create( "DTextEntry", self )
	self.FileName:SetPos(5,51)
	self.FileName:SetSize(self:GetWide() - 10,20)
	self.FileName:SetText("")
	
	self.lab = vgui.Create("DLabel",self)
	self.lab:SetText("Outfit Name")
	self.lab:SizeToContents()
	self.lab:SetPos(5,26)
	
	self.check = vgui.Create("DCheckBoxLabel",self)
	self.check:SetPos(8, 129)
	self.check:SetText("Save individual parts")
	self.check:SetSize(self:GetWide() - 10, 20)
	self.check:SetToolTip("When check PAC willsave the parts inside the outfit dir and the parts dir")
end

function SaveToServer(name,checked)
	RunConsoleCommand("pac_newoutfit", name:gsub("[%W]", ""))
	for k,v in pairs(PAC_OUTFIT.PARTS) do
		local FileName = name:gsub("[%W]", "")..k
		local HatModel = v.Ent:GetModel() or "models/dav0r/hoverball.mdl"
		local X = -v.Pos.x
		local Y = v.Pos.y
		local Z = v.Pos.z
		
		local Scale = v.Scale[1]
		local ScaleX = v.Scale[2]
		local ScaleY = v.Scale[3]
		local ScaleZ = v.Scale[4]
		
		local R = v.Color.r
		local G = v.Color.g
		local B = v.Color.b
		local A = v.Color.a
		
		local Pitch = -v.Angles.p
		local Yaw = v.Angles.y
		local Roll = v.Angles.r
		

		local Bone = v.Bone

			
		local HatMaterial = v.Mat
		
		local chked = tostring(checked)
		
		RunConsoleCommand(
		"pac_make", 
		FileName, 
		HatModel, 
		
		X, 
		Y, 
		Z, 
		
		Scale, 
		
		Pitch, 
		Yaw, 
		Roll, 
		
		ScaleX, 
		ScaleY, 
		ScaleZ, 
		
		R, 
		G, 
		B, 
		A, 
		
		Bone,
		HatMaterial,
		chked)
	end
end

function SaveToClient(name,checked)
	RunConsoleCommand("pac_newoutfitclient", name:gsub("[%W]", ""))
	for k,v in pairs(PAC_OUTFIT.PARTS) do
		local FileName = name:gsub("[%W]", "")..k
		local HatModel = v.Ent:GetModel() or "models/dav0r/hoverball.mdl"
		local X = -v.Pos.x
		local Y = v.Pos.y
		local Z = v.Pos.z
		
		local Scale = v.Scale[1]
		local ScaleX = v.Scale[2]
		local ScaleY = v.Scale[3]
		local ScaleZ = v.Scale[4]
		
		local R = v.Color.r
		local G = v.Color.g
		local B = v.Color.b
		local A = v.Color.a
		
		local Pitch = -v.Angles.p
		local Yaw = v.Angles.y
		local Roll = v.Angles.r
		

		local Bone = v.Bone

			
		local HatMaterial = v.Mat
		
		local chked = tostring(checked)
		
		RunConsoleCommand(
		"pac_makeclient", 
		FileName, 
		HatModel, 
		
		X, 
		Y, 
		Z, 
		
		Scale, 
		
		Pitch, 
		Yaw, 
		Roll, 
		
		ScaleX, 
		ScaleY, 
		ScaleZ, 
		
		R, 
		G, 
		B, 
		A, 
		
		Bone,
		HatMaterial,
		chked)
	end
end

vgui.Register("PAC_FileSave", SAVE, "PAC_Module")

local ANIM = {}

function ANIM:Init()
	self:SetTitle("Animate")
	self:SetSize(200,100)
	self.playbut = vgui.Create("DButton", self)
	self.playbut:SetText("Play")
	local width = (self:GetWide() - 15) / 3
	self.playbut:SetPos(5, 25)
	self.playbut:SetSize(width,21)
	self.playbut.DoClick = function (but)	
								--local iSeq = PAC_EDITOR.preview:GetEntity():LookupSequence( "walk_all" )
								local iSeq = PAC_EDITOR.preview:GetEntity():LookupSequence( "walk_all" )
								PAC_EDITOR.preview:GetEntity():ResetSequence( iSeq )
								PAC_EDITOR.preview:SetAnimated(true)
							end
	self.pausebut = vgui.Create("DButton", self)
	self.pausebut:SetText("Pause")
	self.pausebut:SetPos(width + 10, 25)
	self.pausebut:SetSize(width,21)
	self.pausebut.DoClick = function (but)	
								PAC_EDITOR.preview:SetAnimated(false)
							end
	self.resetbut = vgui.Create("DButton", self)
	self.resetbut:SetText("Reset")
	self.resetbut:SetPos(width + width + 10, 25)
	self.resetbut:SetSize(width,21)
	self.resetbut.DoClick = function (but)	
								local iSeq = PAC_EDITOR.preview:GetEntity():LookupSequence( "idle" )
								PAC_EDITOR.preview:GetEntity():ResetSequence( iSeq )
							end
	self.slid = vgui.Create("DNumSlider", self)
	function self.slid:OnValueChanged( val )
		PAC_EDITOR.preview:SetAnimSpeed(val)
	end
	self.slid:SetWide(self:GetWide() - 10) 
	self.slid:SetPos(5,50)
	self.slid:SetText("Animation Speed")
	self.slid:SetMin(0.01)
	self.slid:SetValue(1)
	self.slid:SetMax(1)
end

vgui.Register("PAC_Animator", ANIM, "PAC_Module")

local PANEL = {}

/*---------------------------------------------------------
   Name: Paint
---------------------------------------------------------*/
function PANEL:Init()
	
	self.IconList = vgui.Create( "DPanelList", self )
	self.IconList:EnableVerticalScrollbar( true )
	self.IconList:EnableHorizontal( true )
	self.IconList:SetPadding( 4 )
	
	self.PropList = vgui.Create( "DListView", self )
	self.PropList:SetDataHeight( 16 )
	self.PropList:AddColumn( "#Name" )
	self.PropList.DoDoubleClick = function( PropList, RowNumber, Line ) self:OnRowClick( RowNumber, Line ) end
	self.PropList:SetMultiSelect( false )
	
	self.PropList.OnRowRightClick = function( PropList, RowNumber, Line ) 
	
										local models = { Line.Model }
										self:OpenContextMenu( models ) 
										
									end
	
	self:SetBottom( self.IconList )
	
	self:SetViewMode( "Icon" )
	
	self:SetIconSize( 64 )
	
	self.Folders = vgui.Create( "DTree" )
	self.Folders:SetPadding( 5 )
	
	local pFolder = self.Folders:AddNode( "All" )
	pFolder:MakeFolder( "models", false )
	
	self.Folders.DoClick = function( tree, node ) return self:ModelBrowse( node.FileName ) end
	
	self:SetTop( self.Folders )
	
	self:AddRootFolder( "Garry's Mod", "../garrysmod/models" )
	
	//
	// Add content (css, dod etc)
	//
	local Content = GetMountedContent()
	for NiceName, FolderName in pairs( Content ) do
		
		self:AddRootFolder( NiceName, "../"..FolderName.."/models" )
		
	end
	
	//
	// Add addons (model packs etc)
	//
	local Addons = GetAddonList()
	for index, Name in pairs( Addons ) do
		
		self:AddRootFolder( Name, "addons/"..Name.."/models" )
		
	end
	
end

/*---------------------------------------------------------
   Name: Init
---------------------------------------------------------*/
function PANEL:AddRootFolder( strName, strPath )

	if ( !file.Exists( strPath, true ) ) then
		return
	end

	local pFolder = self.Folders:AddNode( strName )
	pFolder:MakeFolder( strPath, false )

end

function PANEL:AddModel( strModel )
	
	// Make icon 
	local icon = vgui.Create( "SpawnIcon", self )
	icon:SetModel( strModel )
	icon.DoClick = function( icon )
						if self:GetParent().editmodetab then
							PAC_EDITOR:ModifyPart(self:GetParent().editmodetab,strModel, nil) self:GetParent():Close()
						else
							PAC_EDITOR:AddPart(strModel, nil) self:GetParent():Close()
						end
					end
	icon:SetIconSize( self.m_iIconSize )
	icon:InvalidateLayout( true )
	
	self.IconList:AddItem( icon )
end


/*---------------------------------------------------------
   Name: Init
---------------------------------------------------------*/
function PANEL:Clear()
	
	// Clear
	self.IconList:Clear()
	self.PropList:Clear()
	
end

/*---------------------------------------------------------
   Name: ModelBrowse
---------------------------------------------------------*/
function PANEL:ModelBrowse( strPath )
	
	// Return false if we're already viewing this path.
	// This causes the tree to be openable via name click.
	if ( self.ViewingPath == strPath ) then return false end
	self.ViewingPath = strPath
	
	self:Clear()
	
	local SearchString = strPath .. "/*.mdl"
	local CleanPath = strPath
	
	// Find the first location of "models"
	local findpos = CleanPath:find( "models" )
	if ( !findpos ) then	return end
	
	// Remove everything before models
	CleanPath = CleanPath:sub( findpos )
	
	local Models = file.Find( SearchString, true )
	
	for k, v in pairs( Models ) do
	
		if ( !UTIL_IsUselessModel( v ) ) then
			self:AddModel( CleanPath .. "/" .. v )
		end
	
	end
	
	self.IconList:Rebuild()
	self.IconList:InvalidateLayout()
	
	self.PropList:InvalidateLayout()
	
	return true
	
end

/*---------------------------------------------------------
   Name: OnRowClick
---------------------------------------------------------*/
function PANEL:OnRowClick( LineID, Line )

	surface.PlaySound( "ui/buttonclickrelease.wav")
	RunConsoleCommand( "gm_spawn", Line.Model )
	
end



/*---------------------------------------------------------
   Name: SetViewMode
---------------------------------------------------------*/
function PANEL:SetViewMode( strName )

	self.IconList:SetVisible( false )
	self.PropList:SetVisible( false )

	if ( strName == "Icon" ) then
		self.IconList:SetVisible( true )
		self:SetBottom( self.IconList )
	end
	
	if ( strName == "List" ) then
		self.PropList:SetVisible( true )
		self:SetBottom( self.PropList )
	end
	
	self:InvalidateLayout()

end

/*---------------------------------------------------------
   Name: SetIconSize
---------------------------------------------------------*/
function PANEL:SetIconSize( iconSize )

	self.m_iIconSize = iconSize
	
	local items = self.IconList:GetItems()
	
	for k, v in pairs( items ) do
	
		v:SetIconSize( self.m_iIconSize )
		v:InvalidateLayout( true )
	
	end
	
	self.IconList:InvalidateLayout()
	
end


/*---------------------------------------------------------
   Name: AddPropsToCategory
---------------------------------------------------------*/
function PANEL:AddPropsToCategory( category )

	local data = self.PropList:GetLines()

	for k, v in pairs( data ) do
		spawnmenu.AddProp( category, v.Model )
	end
	
	g_PropSpawnController:RebuildPropList( category )
	
	SpawnMenuEnableSave()
	
end

vgui.Register( "PAC_Browser", PANEL, "DVerticalDivider" )


